#!/usr/bin/perl
#
# $Id: bind-larrd.pl,v 1.9 2003/03/18 16:48:12 cncook Exp $
#
# bind-larrd.pl: larrd module to collect bind stats
#
# Scott Walters Copyright 1999, 2000
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# this is for after install
use lib $ENV{'RRDPM'};
use RRDs;

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

#
# add statistics-intervel 5; to your options in named.conf if you run bind
#

$ds = "bind";

# Bind DS's

@ds = ("DS:A:DERIVE:600:0:U",    # network address
            "DS:ANY:DERIVE:600:0:U",  # all/any information
            "DS:AXFR:DERIVE:600:0:U",
            "DS:MX:DERIVE:600:0:U",   # mail exchanger
            "DS:O:DERIVE:600:0:U",    # ?
            "DS:PTR:DERIVE:600:0:U",  # ?
            "DS:SOA:DERIVE:600:0:U"); # zone of authority record

%bind_type = ("A"   =>1,
              "ANY" =>1,
              "AXFR"=>1,
              "MX"  =>1,
              "O"   =>1,
              "PTR" =>1,
              "SOA" =>1);

# NOTE : See README about $ENV{'LARRDCOMM'}

# $ENV{'LARRDCOMM'} has gone away.  Only the bottom feeders
# specify how the data gets there.  The larrd drivers look in
# the logs directory first.  Then they look in the data directory.
# Data logs take precedence.

# Glob the bind logs and data
my %h_fn;

# Perl Cookbook Recipe 9.5
opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
	next unless $log =~ /\.$ds$/io;
	my $host = $log;
	$host =~ s/\.$ds//;
	$host =~ s/\,/\./g;

	$h_fn{$host}="$ENV{'BBLOGS'}/$log";
}
closedir(DIR);

opendir(DIR, "$ENV{'BBVAR'}/data") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
	next unless $log =~ /\.$ds$/io;
	my $host = $log;
	$host =~ s/\.$ds//;
	$host =~ s/\,/\./g;

	$h_fn{$host}="$ENV{'BBVAR'}/data/$log";
}
closedir(DIR);

while ( ($host,$log) = each %h_fn ) {


	print "$0 : DEBUG log=$log\n" if ($ENV{'DEBUG'});

	open(LOG,"$log");
	
	$temp = <LOG> if $log =~ /$ENV{'BBLOGS'}/io;

	$bind = <LOG>;

	print "$0: DEBUG bind = $bind\n" if ($ENV{'DEBUG'});

	close(LOG);

        chomp $bind;

        ($crap,$stats) = split "]: ",$bind;

        ($crap,$ctime,$crap,@stats) = split " ",$stats;

        local(%stats_h);
        foreach (@stats) {
		($type,$value) = split "=";

		print "$0: DEBUG type = $type, value = $value\n" if ($ENV{'DEBUG'});

		$stats_h{$type}=$value;
	}

	$RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

	print "$0: DEBUG RRD = $RRD\n" if ($ENV{'DEBUG'});

	print "$0: DEBUG ds = @ds\n" if ($ENV{'DEBUG'});

	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {
		
		# but thought 'standardizing' RRD's would be worth it
		# 30 seconds....
		@rras = split " ",$ENV{'RRAS'};
		RRDs::create($RRD,"--start","$ctime-1",@ds,@rras);
		$ERR=RRDs::error;
		if($ERR) {
			print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
			next; #does this work? yup!
		}
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

	local($rrdupdate_t);
	foreach $col ( sort keys %bind_type) { 
		$rrdupdate_t = "$rrdupdate_t$col:";
	}
        chop $rrdupdate_t;

	print "$0: DEBUG rrdupdate_t = $rrdupdate_t\n" if ($ENV{'DEBUG'});

	local($rrdupdate)="$ctime";
	foreach $col ( sort keys %bind_type) { 
		$stats_h{$col} = 0 unless $stats_h{$col};
		$rrdupdate = "$rrdupdate:$stats_h{$col}";
	}

	print "$0: DEBUG rrdupdate = $rrdupdate\n" if ($ENV{'DEBUG'});

	# now update the RRD
	RRDs::update("$RRD","-t","$rrdupdate_t","$rrdupdate");
        $ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'})
;
        }
        unlink $log if $log =~ /$ENV{'BBVAR'}\/data/io;

}	
##############################################
# end of script
##############################################

