#!/usr/bin/perl
#
# $Id: disk-larrd.pl,v 1.14 2003/03/18 16:48:12 cncook Exp $
#
# disk-larrd.pl: larrd module to collect disk utilization stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Craig Cook 13 Mar 2003
# Created @ds
# Created $ds
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

$ds = "disk";

@ds = ("DS:pct:GAUGE:600:0:100",
       "DS:used:GAUGE:600:0:U"
      );

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBLOGS'}";

# Glob the disk logs
LOG: while (  defined ($log = <*.$ds>)  ) {

        $host=$log;
        # create some handy vars
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        # Slurp the log into an array for now and later use
        open(LOG,"$log");
        @log=<LOG>;
        close(LOG);
	
	($ctime) = (stat($log))[10];

        if($log[0] !~ /green|yellow|red/) {
                print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
                next LOG;
        }

	# Ugly I know, but effiecent
	$whole = join "",@log;

	# Decide the client system type
	if($whole =~ / xfs | efs | cxfs / ) {
		$systemtype="IRIX";
        } elsif ($whole =~ /DASD/ ) { 
		$systemtype="AS400";
	} elsif ($whole =~ /Filesystem/ ) { # Hope this doesn't break
		# It seems that UNIX don't have Filesystem in the LOG
		$systemtype="NT";
	} else {
		$systemtype="UNIX";
	}

	foreach $line (@log) {
		next if ($line =~/^&/);
		next if ($line !~/\// && $systemtype ne "AS400" );
		next if ($line !~/DASD/ && $systemtype eq "AS400" );
		next if ($line =~/^\s+(yellow|red)\s+\//);
		last if ($line =~/bloater/);

		print "$0: DEBUG $line\n" if $ENV{'DEBUG'};

		@col = split " ",$line;

		# sometimes NT is wierd
                # what am i'm saying it's always wierd.
                # can i waste any more CPU cycles?
		if ( $systemtype eq "AS400" ) {
			$diskname=",DASD"; 
		} elsif ( $systemtype eq "NT" ) {
			$diskname="\,$col[0]";
		} elsif ( $systemtype eq "IRIX" ) {
		        # /'s are a nasty thing to have in filenames
		        $col[6] =~ s/\//\,/g;
			$diskname=$col[6];
		} else {
		        # /'s are a nasty thing to have in filenames
		        $col[5] =~ s/\//\,/g;
			$diskname=$col[5]; 
		}

		# want / filesytems to have nice name
                if ( $diskname eq "\," ) {
                        $diskname="\,root"
		}
	
		$RRD="$ENV{'BBRRDS'}/$host.disk$diskname.rrd";
	
	        # if it doesn't exist, make it
       		if ( not -f $RRD ) {
                        # RRAS defined in larrd.pl
                        @rras = split " ",$ENV{'RRAS'};
                        RRDs::create($RRD,@ds,@rras);
                        $ERR=RRDs::error;
                        if($ERR) {
                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next;
                        }
			# New RRDs don't like old dates
			$ctime="N";
                	print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'}); 
        	}

                # going to get % cause it is relative
		if ( $systemtype eq "AS400" ) {
			$col12 =~ s/%//g;
			$pct=$col[12];
		} elsif ( $systemtype eq "IRIX" ) {
		        $col[5] =~ s/%//g;
			$pct=$col[5];
		} else {
		        $col[4] =~ s/%//g;
			$pct=$col[4];
		}

                # going to get used cause it is absolute
		if ( $systemtype eq "AS400" ) {
			$used=0;	
		} elsif ( $systemtype eq "IRIX" ) {
                	$used=$col[3];
		} else {
                	$used=$col[2];
		}
	
		print "$RRD $ctime:$pct:$used\n" if ($ENV{'DEBUG'});

	        RRDs::update("$RRD","$ctime:$pct:$used");
        	$ERR=RRDs::error;
        	if($ERR) {
               		print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        	}
	}
}	
##############################################
# end of script
##############################################
