#!/usr/bin/perl
#
# $Id: vmstat-larrd.pl,v 1.8 2003/03/18 16:48:12 cncook Exp $
#
# vmstat-larrd.pl: larrd module to collect disk utilization stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# this is for after install
use lib $ENV{'RRDPM'};
use RRDs;

$ds = "vmstat";

# Define some host vmstat hash column translation

%htovm = (solaris => { cpu_r     => 0,
                       cpu_b     => 1,
		       cpu_w     => 2,
		       mem_swap  => 3,
	   	       mem_free  => 4,
 		       mem_re    => 5,
		       mem_mf    => 6,
		       mem_pi    => 7,
		       mem_po    => 8,
		       sr        => 11,
                       cpu_int   => 16,
                       cpu_syc   => 17,
                       cpu_csw   => 18,
		       cpu_usr   => 19,
                       cpu_sys   => 20,
                       cpu_idl   => 21,
		     },
	  redhat => {  cpu_r    => 0,
                       cpu_b    => 1,
		       cpu_w    => 2,
		       mem_swpd => 3,
		       mem_free => 4,
           	       mem_buff => 5,
                       mem_cach => 6,
      		       mem_si   => 7,
                       mem_so   => 8,
		       dsk_bi   => 9,
		       dsk_bo   => 10,
                       cpu_int  => 11,
                       cpu_csw  => 12,
		       cpu_usr  => 13,
                       cpu_sys  => 14,
                       cpu_idl  => 15,
		     },
          osf => {     cpu_r    => 0, 
                       cpu_b    => 1, 
                       cpu_w    => 2, 
                       mem_free => 4, 
                       mem_mf   => 6, 
                       mem_pi   => 10, 
                       mem_po   => 11, 
                       cpu_int  => 12, 
                       cpu_syc  => 13, 
                       cpu_csw  => 14, 
                       cpu_usr  => 15, 
                       cpu_sys  => 16, 
                       cpu_idl  => 17, 
                 }, 
          aix     => {  cpu_r    => 0,
                        cpu_b    => 1,
                        mem_avm  => 2,
                        mem_free => 3,
                        mem_re   => 4,
                        mem_pi   => 5,
                        mem_po   => 6,
                        mem_fr   => 7,
                        sr       => 8,
                        mem_cy   => 9,
                        cpu_int  => 10,
                        cpu_syc  => 11,
                        cpu_csw  => 12,
                        cpu_usr  => 13,
                        cpu_sys  => 14,
                        cpu_idl  => 15,
                        cpu_wait => 16,
                     },
	  freebsd => {  cpu_r    => 0,
                        cpu_b    => 1,
                        cpu_w    => 2,
                        mem_avm  => 3,
                        mem_free => 4,
                        mem_flt  => 5,
                        mem_re   => 6,
                        mem_pi   => 7,
                        mem_po   => 8,
                        mem_fr   => 9,
                        sr       => 10,
                        dsk_da0  => 11,
                        dsk_fd0  => 12,
                        cpu_int  => 13,
                        cpu_csw  => 15,
                        cpu_sys  => 16,
                        cpu_usr  => 17,
                        cpu_idl  => 18,
                     },
	 );

# Aliases
$htovm{'debian'}=$htovm{'redhat'};

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# NOTE : See README about $ENV{'LARRDCOMM'}

# Glob the bind logs and data
my %h_fn;

# Perl Cookbook Recipe 9.5
opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBLOGS'}/$log";
}
closedir(DIR);

opendir(DIR, "$ENV{'BBVAR'}/data") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBVAR'}/data/$log";
}
closedir(DIR);

while ( ($host,$log) = each %h_fn ) {

        print "$0 : DEBUG log=$log\n" if ($ENV{'DEBUG'});

# 2. grab the timpstamp for rrd.

        ($ctime) = (stat($log))[10];

	print "$0 : DEBUG ctime = $ctime\n" if ($ENV{'DEBUG'});

	open(LOG,"$log");
        $temp = <LOG> if $log =~ /$ENV{'BBLOGS'}/io;
	$bbhosttype = <LOG>;

	chomp $bbhosttype;

	print "$0: DEBUG bbhosttype = $bbhosttype\n" if ($ENV{'DEBUG'});

	$vmstat = <LOG>;

	print "$0: DEBUG vmstat = $vmstat\n" if ($ENV{'DEBUG'});

	close(LOG);

        chomp $vmstat;

        @cols = split " ",$vmstat;

	$RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

	print "$0: DEBUG RRD = $RRD\n" if ($ENV{'DEBUG'});

# TODO optimize the kludge if the DS, since solaris has sy for faults and
# TODO redhat doesn't blah! fix is to put it into a loop and create it on
# TODO the fly

	local(@ds);
	foreach $col ( sort keys %{$htovm{$bbhosttype}}) {
		push @ds,"DS:$col:GAUGE:600:0:U";
	}

	print "$0: DEBUG ds = @ds\n" if ($ENV{'DEBUG'});

	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {
		
		# keeping this much disk data seems overkill
		# but thought 'standardizing' RRD's would be worth it
		# 30 seconds....
		@rras = split " ",$ENV{'RRAS'};
		RRDs::create($RRD,@ds,@rras);
		$ERR=RRDs::error;
		if($ERR) {
			print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
			next; #does this work? yup!
		}
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

	local($rrdupdate)="$ctime";

	foreach $col ( sort keys %{$htovm{$bbhosttype}}) { 
		$rrdupdate = "$rrdupdate:$cols[$htovm{$bbhosttype}{$col}]";
	}

	print "$0: DEBUG rrdupdate = $rrdupdate\n" if ($ENV{'DEBUG'});

	# now update the RRD
	RRDs::update("$RRD","$rrdupdate");
        $ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'})
;
        }
        unlink $log if $log =~ /$ENV{'BBVAR'}\/data/io;

}	
##############################################
# end of script
##############################################

