#!/usr/bin/perl -Tw

# Nicolas-Baptiste CHUCHE (nchuche@teaser.fr)
# v 0.1

# Description
# Perl CGI where you select a statistic and a period to see all the graphs
# it's not a part of larrd or of bb but just a "plugin"

# As usual, use it at your own risk...


# INSTALL
# To install this CGI :
# 1 - put it in you cgi-bin directory (perhaps /home/httpd/cgi-bin)
# 2 - made it executable for the http user
# 3 - change the BBWEB and BBHOME variables
# 4 - call it in a browser and try

use strict;
use CGI qw/:standard/;

# YOU MUST CHANGE THIS

my $BBWEB   = "http://localhost/bb";	# Location of Big Brother Web Server
my $BBHOME  = "/usr/local/bb";         # BB Location

# NOT THIS

my $BBGRAPH = "$BBHOME/www/graphs";     # Location of Larrd graph files

# for the tainted option
$ENV{PATH} = "/bin:/usr/bin";
delete @ENV{qw(SHELL IFS CDPATH ENV BASH_ENV)};

print header,
  start_html('Larrd selection');

($BBHOME eq "" || $BBWEB eq "")
  && show_error("BBHOME or BBWEB IS NOT SET IN larrd.pl");

my (%hash, @serveurs);

# I don't use glob 'cause taint doesn't like that
opendir DIR, "$BBGRAPH" or die "unable to open the directory";
my @files = grep { ! /^\./ && -r "$BBGRAPH/$_" } readdir(DIR);
closedir DIR;

# we build the hash which reference the graphs
# on the period and the stat name

foreach my $file_name (@files) {
  my ($serveur, $stat, $periode) = $file_name =~ /(.+)\.(\w+)\.(\w+)\.png/;
  push @{$hash{$periode}{$stat}}, $serveur;
}

# we build the tables which do the radio_group in the form
my @periode = keys %hash;
my @stat = keys %{@hash{@periode}};

# we send the graphics
if (param()) {

  my ($periode, $stat) = (param('periode'), param('stat'));

  ( ! defined $hash{$periode}{$stat} )
    && show_error('This statistic doesn\'t exist on this periode');

  print "<center>";
  print h1("<em>$stat</em> statistics on <em>$periode</em> period");

  foreach my $serveur (@{$hash{$periode}{$stat}}) {
    print "<img src=\"$BBWEB/graphs/$serveur.$stat.$periode.png\">", p;
  }
  print "</center>";

}

# we build the select form
print hr, "<center>",
  h1('Larrd selection'),
  start_form,
  #  "<table><td><tr>",
  "Select the period : ",
  radio_group(-name=>'periode',
	      -values=>[@periode],
	      -default=>'hourly'), p,
  #  "</tr><tr>",
  "Select the stat : ",
  radio_group(-name=>'stat',
	      -values=>[@stat]), p,
  #  "</tr></td></table>",
  submit,
  end_form,
  "</center>",
  hr;

# we write the rrd logo with the link to Tobia's rrdtool's homepage
print <<pied_de_page;
<BR>
larrd is proud to be:
<A HREF="http://ee-staff.ethz.ch/~oetiker/webtools/rrdtool/">
<IMG SRC="$BBWEB/gifs/rrdtool.gif"></A>
pied_de_page


print end_html;

# error handling
sub show_error {
  my $message = shift;

  print start_html('Larrd error'),
    h1("ERROR - " . $message),
      end_html;

  exit 1;
}
