#!/usr/bin/perl
#
# nt-larrd.pl - larrd module for collecting NT Memory utilisation
#
# Nicolas-Baptiste Chuche Copyright 2000
#
# based on la-larrd.pl from :
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#
# Christian Pearce
# pearcec@PacketPushers.com
#
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;
use Time::Local;

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBHOME'}/www/logs";

# Glob the mem logs
while (  defined ($log = <*.cpu>)  ) {

  $host=$log;
  # create some handy vars
  $host =~ s/\.cpu//;
  $host =~ s/\,/\./g;

  # Grab Load Avg line
  open(LOG,"$log");
  $line=<LOG>;
  close(LOG);

  chomp $line;

  $timestamp=$line;

  $mtime="N";
  my $mem;
  if($line =~ /%/) {
    # This might break NT, but hope it didn't lose
    # anything in the translation of Andreas Holzhammer fix
    ($mem) = $line =~ /\((\d+)%\)/;

    # getting RRD

    $RRD="$ENV{'BBRRDS'}/$host.mem.rrd";

    # if it doesn't exist, make it
    if ( not -f $RRD ) {
      # RRAS defined in larrd.pl
      @rras = split " ",$ENV{'RRAS'};
      RRDs::create($RRD,"DS:mem:GAUGE:600:0:U",@rras);
      $ERR=RRDs::error;
      if($ERR) {
	print "$0: ERROR creating $RRD: $ERR\n";
      }
      $mtime="N";
      print "$0 did not find $RRD, created.\n"
    }

    RRDs::update("$RRD","$mtime:$mem");
    # print "$RRD $mtime:$mem\n";
    $ERR=RRDs::error;
    if($ERR) {
      print "$0: ERROR updating $RRD: $ERR\n";
    }
  }
}
##############################################
# end of script
##############################################

