#!/usr/bin/perl -w

use strict;
use RRDs;

opendir (DIR,".");
my @rrds = grep { ! /^\./ } readdir DIR;
close (DIR);

foreach my $rrd (@rrds) {

    my $hash = RRDs::info $rrd;

    foreach my $key ( keys %{$hash} ) {
	next unless $key =~ /type/;
        if($hash->{$key} eq "COUNTER") {
            my ($t) = $key =~ /ds\[(.*)\]\.type/;
            RRDs::tune $rrd,"-i","$t:0","-d","$t:DERIVE";
            my $ERR=RRDs::error;
            if($ERR) {
                print "Error tuning $rrd from counter -> derive for $t : $ERR\n";
            }

        }
    }
}
            
